## rmtfs 1.1

=== Makefile ===
OUT := rmtfs

CFLAGS += -Wall -g -O2
LDFLAGS += -lqrtr -ludev -lpthread
prefix = /usr/local
bindir := $(prefix)/bin
servicedir := $(prefix)/lib/systemd/system

SRCS := qmi_rmtfs.c rmtfs.c rproc.c sharedmem.c storage.c util.c
OBJS := $(SRCS:.c=.o)

$(OUT): $(OBJS)
	$(CC) -o $@ $^ $(LDFLAGS)

%.c: %.qmi
	qmic -k < $<

rmtfs.service: rmtfs.service.in
	@sed 's+RMTFS_PATH+$(bindir)+g' $< > $@

install: $(OUT) rmtfs.service
	@install -D -m 755 $(OUT) $(DESTDIR)$(prefix)/bin/$(OUT)
	@install -D -m 644 rmtfs.service $(DESTDIR)$(servicedir)/rmtfs.service

clean:
	rm -f $(OUT) $(OBJS) rmtfs.service

## rmtfs 0.2+git20220718

=== debian/changelog ===
rmtfs (0.2+git20220718-2) unstable; urgency=medium

  * Source-only upload to allow transition to testing

 -- Arnaud Ferraris <aferraris@debian.org>  Fri, 05 Aug 2022 10:55:46 +0200

rmtfs (0.2+git20220718-1) unstable; urgency=medium

  * Initial Debian packaging (Closes: #1016012)

 -- Arnaud Ferraris <aferraris@debian.org>  Mon, 25 Jul 2022 13:11:00 +0200

=== debian/control ===
Source: rmtfs
Section: net
Priority: optional
Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders: Arnaud Ferraris <aferraris@debian.org>
Standards-Version: 4.6.1
Build-Depends: debhelper-compat (= 13),
               libqrtr-dev,
               libudev-dev,
Homepage: https://github.com/andersson/rmtfs
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/rmtfs.git
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/rmtfs
Rules-Requires-Root: no

Package: rmtfs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Qualcomm Remote Filesystem Service implementation
 This package contains the reference implementation for Qualcomm's Remote
 Filesystem service.
 .
 It allows userspace applications to access the shared memory and internal
 storage of the remote processors (Wi-Fi, modem, sensors...) found on recent
 Qualcomm SoCs, using the QMI and QRTR protocols.

## rmtfs 1.0

=== debian/changelog ===
rmtfs (1.0-3) unstable; urgency=medium

  * Upload to unstable

 -- Arnaud Ferraris <aferraris@debian.org>  Tue, 02 Jan 2024 09:28:14 +0100

rmtfs (1.0-3~exp1) experimental; urgency=medium

  * d/gbp.conf: use 'debian/experimental' as debian branch
  * debian: keep systemd service under /usr.
    In the current state of the Debian "/usr merge", we are allowed to move
    systemd services under `/usr/lib/systemd` when relying on
    `dh_installsystemd`. This requires adding a versioned dependency on
    `debhelper`.
    Let's comply by no longer moving `/usr/lib` to `/`.

 -- Arnaud Ferraris <aferraris@debian.org>  Mon, 30 Oct 2023 17:19:47 +0100

rmtfs (1.0-2) unstable; urgency=medium

  * d/rules: install service file under `/lib/systemd`
    `debhelper` looks for service files under `/lib/systemd`, but ignores
    those installed under `/usr/lib/systemd`, so we need to install our
    service file to the former location to have it auto-enabled on install.

 -- Arnaud Ferraris <aferraris@debian.org>  Wed, 11 Jan 2023 00:15:40 +0100

rmtfs (1.0-1) unstable; urgency=medium

  * New upstream version 1.0
  * d/control: bump Standards-Version, no change required

 -- Arnaud Ferraris <aferraris@debian.org>  Tue, 03 Jan 2023 10:17:13 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders: Arnaud Ferraris <aferraris@debian.org>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Build-Depends: debhelper-compat (= 13),
+               debhelper (>= 13.11.6),
                libqrtr-dev,
                libudev-dev,
 Homepage: https://github.com/andersson/rmtfs

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export RMTFS_BUILD_OPTS=prefix=/usr

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- ${RMTFS_BUILD_OPTS}

override_dh_auto_install:
	dh_auto_install -- ${RMTFS_BUILD_OPTS}

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rmtfs-$1.tar.gz%" \
   https://github.com/andersson/rmtfs/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## rmtfs 1.1

=== debian/changelog ===
rmtfs (1.1-2) unstable; urgency=medium

  * debian: add udeb package.
    This makes it possible to include this package in debian-installer
    images, allowing users to use remote processors (e.g. WiFi) when running
    on Qualcomm-based hardware. (Closes: #1076726)

 -- Arnaud Ferraris <aferraris@debian.org>  Mon, 03 Feb 2025 17:01:58 +0100

rmtfs (1.1-1) unstable; urgency=medium

  * New upstream version
  * debian: update references to upstream URL.
    This project is now part of the `linux-msm` group on GitHub, and its
    main maintainer is now Konrad Dybcio. While at it, bump
    Standards-Version as no other change is required.
  * d/gbp.conf: align with other similar DebianOnMobile packages

 -- Arnaud Ferraris <aferraris@debian.org>  Mon, 27 Jan 2025 18:32:20 +0100

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders: Arnaud Ferraris <aferraris@debian.org>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Build-Depends: debhelper-compat (= 13),
                debhelper (>= 13.11.6),
                libqrtr-dev,
                libudev-dev,
-Homepage: https://github.com/andersson/rmtfs
+Homepage: https://github.com/linux-msm/rmtfs
 Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/rmtfs.git
 Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/rmtfs
 Rules-Requires-Root: no
@@ -24,3 +24,20 @@
  It allows userspace applications to access the shared memory and internal
  storage of the remote processors (Wi-Fi, modem, sensors...) found on recent
  Qualcomm SoCs, using the QMI and QRTR protocols.
+
+Package: rmtfs-udeb
+Build-Profiles: <!noudeb>
+Package-Type: udeb
+Section: debian-installer
+Architecture: any
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+Description: Qualcomm Remote Filesystem Service implementation
+ This is a udeb, or a microdeb, for the debian-installer.
+ .
+ This package contains the reference implementation for Qualcomm's Remote
+ Filesystem service.
+ .
+ It allows userspace applications to access the shared memory and internal
+ storage of the remote processors (Wi-Fi, modem, sensors...) found on recent
+ Qualcomm SoCs, using the QMI and QRTR protocols.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rmtfs-$1.tar.gz%" \
   https://github.com/linux-msm/rmtfs/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## rmtfs 1.1.1

=== Makefile ===
OUT := rmtfs

CFLAGS += -Wall -g -O2
LDFLAGS += -lqrtr -ludev -lpthread
prefix = /usr/local
bindir := $(prefix)/bin
servicedir := $(prefix)/lib/systemd/system

RMTFS_EFS_PATH ?= /var/lib/rmtfs

SRCS := qmi_rmtfs.c rmtfs.c rproc.c sharedmem.c storage.c util.c
OBJS := $(SRCS:.c=.o)

$(OUT): $(OBJS)
	$(CC) -o $@ $^ $(LDFLAGS)

%.c: %.qmi
	qmic -k < $<

%.service: %.service.in
	@sed -e 's+RMTFS_PATH+$(bindir)+g' -e 's+RMTFS_EFS_PATH+$(RMTFS_EFS_PATH)+g' $< > $@

install: $(OUT) rmtfs.service rmtfs-dir.service
	@install -D -m 755 $(OUT) $(DESTDIR)$(prefix)/bin/$(OUT)
	@install -D -m 644 rmtfs.service $(DESTDIR)$(servicedir)/rmtfs.service
	@install -D -m 644 rmtfs-dir.service $(DESTDIR)$(servicedir)/rmtfs-dir.service

clean:
	rm -f $(OUT) $(OBJS) rmtfs.service
	rm -f $(OUT) $(OBJS) rmtfs-dir.service

=== debian/changelog ===
rmtfs (1.1.1-2) unstable; urgency=medium

  * d/rules: disable rmtfs-dir service by default.
    The new `rmtfs-dir` starts another instance of `rmtfs` with different
    parameters. This triggers a race condition with the main `rmtfs` service
    and can cripple a device's functionality if `rmtfs-dir` wins the race.
    Let's ensure this doesn't happen by disabling the latter by default.
    Also take this opportunity to instruct `dh_installsystemd` to avoid
    restarting those services during upgrades as this can lead to losing
    network connectivity. (Closes: #1117938)
  * d/watch: convert to version 5

 -- Arnaud Ferraris <aferraris@debian.org>  Tue, 14 Oct 2025 12:45:14 +0200

rmtfs (1.1.1-1) unstable; urgency=medium

  * New upstream version
  * d/patches: drop backported patches.
    Those are part of the latest release.
  * d/control: bump Standards-Version, drop Rules-Requires-Root

 -- Arnaud Ferraris <aferraris@debian.org>  Mon, 11 Aug 2025 12:00:14 +0200

rmtfs (1.1-4) unstable; urgency=medium

  [ Robie Basak ]
  * Fix wifi crash on shutdown.
    Cherry-picked from upstream: https://github.com/linux-msm/rmtfs/commit/5b214f61b9b82998bf13f4bfd16fe4e2cd29c086
    Downstream bug: https://github.com/qualcomm-linux/qcom-deb-images/issues/40

 -- Arnaud Ferraris <aferraris@debian.org>  Fri, 25 Jul 2025 11:13:29 +0200

rmtfs (1.1-3) unstable; urgency=medium

  * d/control: only build for ARMv7+
    This package is specifically aimed at supporting hardware features of
    modern Qualcomm SoC's, which are all ARM-based (mostly `arm64`, but that
    includes `armhf` parts such as e.g. MSM8916). There's no point shipping
    this package on other architectures, so limit the list to `armhf` and
    `arm64`, while keeping `amd64` as it greatly simplifies running CI and
    debugging builds.
  * d/patches: backport upstream service fix.
    The QRTR nameserver has been built into the kernel for years now, so the
    service no longer needs to depend on `qrtr-ns.service`. (Closes: #1104083)

 -- Arnaud Ferraris <aferraris@debian.org>  Mon, 19 May 2025 12:18:34 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders: Arnaud Ferraris <aferraris@debian.org>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Build-Depends: debhelper-compat (= 13),
                debhelper (>= 13.11.6),
                libqrtr-dev,
@@ -11,10 +11,9 @@
 Homepage: https://github.com/linux-msm/rmtfs
 Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/rmtfs.git
 Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/rmtfs
-Rules-Requires-Root: no
 
 Package: rmtfs
-Architecture: any
+Architecture: amd64 armhf arm64
 Depends: ${misc:Depends},
          ${shlibs:Depends},
 Description: Qualcomm Remote Filesystem Service implementation
@@ -29,7 +28,7 @@
 Build-Profiles: <!noudeb>
 Package-Type: udeb
 Section: debian-installer
-Architecture: any
+Architecture: amd64 armhf arm64
 Depends: ${misc:Depends},
          ${shlibs:Depends},
 Description: Qualcomm Remote Filesystem Service implementation

=== debian/rules ===
--- 
+++ 
@@ -11,3 +11,10 @@
 
 override_dh_auto_install:
 	dh_auto_install -- ${RMTFS_BUILD_OPTS}
+
+# Ensure the rmtfs service isn't stopped during upgrades, # as this can lead to
+# losing network connectivity. Moreover, the rmtfs-dir must be disabled by
+# default in order to prevent race conditions with the main rmtfs service
+override_dh_installsystemd:
+	dh_installsystemd --name rmtfs --no-stop-on-upgrade --no-restart-after-upgrade
+	dh_installsystemd --name rmtfs-dir --no-start --no-enable --no-stop-on-upgrade --no-restart-after-upgrade
